import pandas as pd
import numpy as np

df = pd.read_csv('C:/Users/hp/Desktop/fd.csv',encoding='utf-8')


from sklearn.metrics import mean_squared_error
from sklearn.metrics import r2_score
from sklearn.model_selection import train_test_split
X=df.iloc[:,1:285].values
y=df.iloc[:,0:1].values

X_train,X_test,y_train,y_test=train_test_split(X,y,
                                               test_size=0.2,
                                               random_state=1)
from sklearn.linear_model import Lasso
clf = Lasso(alpha=0.02, fit_intercept=True, normalize=True, precompute=False,
copy_X=True, max_iter=1000,tol=1e-04, warm_start=False,
positive=False,random_state=100,selection='cyclic')

rf = clf.fit (X_train, y_train)
y_train_pred = rf.predict(X_train)
y_test_pred=rf.predict(X_test)

def mean_relative_error(y_true,y_pred):
    relative_error = np.average(np.abs(y_pred-y_true)/y_true,axis=0)
    return relative_error


print('RMSE train:%3f,test:%3f'%(mean_squared_error(y_train,y_train_pred,squared=False),
                               mean_squared_error(y_test,y_test_pred,squared=False)))
print('r2 train:%.3f,test:%.3f'%(r2_score(y_train,y_train_pred),r2_score(y_test,y_test_pred)))


y_train_pred_=y_train_pred.ravel()  
y_test_pred_=y_test_pred.ravel() 
y_train_=y_train.ravel() 
y_test_=y_test.ravel() 
print('RE train:%3f,test:%3f'%(mean_relative_error(y_train_,y_train_pred_),
                               mean_relative_error(y_test_,y_test_pred_)))

import matplotlib.pyplot as plt

plt.scatter(y_test,
            y_test_pred,
            c='steelblue',
            #edgecolor='white',
            marker ='o',
            s=30,
            alpha=0.8
            )




         
from sklearn import linear_model
reg=linear_model.LinearRegression()
x=np.array(y_test).reshape(-1,1)
reg.fit(x,y_test_pred)
y_pred=reg.predict(x)
plt.plot(x,y_pred,color='steelblue',alpha=0.8,linewidth=0.8)
#plt.xlabel('SPAD measured')
#plt.ylabel('SPAD predicted ')
plt.xticks(fontproperties = 'Times New Roman', size = 22)
plt.yticks(fontproperties = 'Times New Roman', size = 22)
plt.ylim([0,70])
plt.xlim([0,70])
plt.tight_layout()
plt.show()

